﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace i8014W_Basic_Info_Csharp
{
    public partial class I_8014W_I_9014 : Form
    {
        public Int16 slotIndex = 0;
        Int16 gain = 0;
        public Int16 maxCh = 0;
        public I_8014W_I_9014()
        {
            InitializeComponent();
        }
        private void I_8014W_I_9014_Load(object sender, EventArgs e)
        {
            Tips_list.Items.Clear();
            Tips_list.Items.Add("For I-8014W and I-9014,");
            Tips_list.Items.Add("Read gain and offset values require 'pac8014W.ReadGainOffset' function");
            Tips_list.Items.Add("Each 'range' has a pair of gain and offset values");
            Tips_list.Items.Add("Step 4 : Select 'Range'");
            Tips_list.Items.Add("Step 5 : Click 'Read AI' button");
            Range_cmb.Items.Add("+/- 10.0 V");
            Range_cmb.Items.Add("+/-  5.0 V");
            Range_cmb.Items.Add("+/-  2.5 V");
            Range_cmb.Items.Add("+/-  1.25 V");
            Range_cmb.Items.Add("+/- 20.0 mA");
        }
        private void Range_cmb_SelectedIndexChanged(object sender, EventArgs e)
        {
            UInt16 gainValue = 0;
            Int16 offsetValue = 0;
            if (Range_cmb.SelectedIndex != -1)
            {
                gain = (short)Range_cmb.SelectedIndex;
                //read gain value and offset value
                pac8014WNet.pac8014W.ReadGainOffset(slotIndex, gain, ref gainValue, ref  offsetValue);
                Gain_Val_lab.Text = gainValue.ToString();
                Offset_Val_lab.Text = offsetValue.ToString();
            }
        }
        private void Read_AI_I8014W_brn_Click(object sender, EventArgs e)
        {
            TextBox[] dara_arr = { txtAI0, txtAI1, txtAI2, txtAI3, txtAI4, txtAI5, txtAI6, txtAI7, txtAI8, txtAI9, txtAI10, txtAI11, txtAI12, txtAI13, txtAI14, txtAI15 };
            Int16 ch = 0;
            float fVal = 0;
            short hVal = 0;
            for (ch = 0; ch < maxCh; ch++)
            {
                if (HEX_Format_ckb.Checked)
                {
                    //read HEX format AI data
                    pac8014WNet.pac8014W.ReadAIHex(slotIndex, ch, gain, ref hVal);
                    dara_arr[ch].Text = hVal.ToString("X4");
                }
                else
                {
                    //read float format AI data
                    pac8014WNet.pac8014W.ReadAI(slotIndex, ch, gain, ref fVal);
                    dara_arr[ch].Text = fVal.ToString("F03");
                }
            }
        }
        private void btnExit_Click(object sender, EventArgs e)
        {
            Close();
        }
    }
}